#!/bin/sh
ts_check_tun=30

. /opt/kelvpn/sbin/kelvpn_func.sh

PIDFILE="/tmp/KelVPNCheck.pid"

if [ -e $PIDFILE ]; then
    pid=`cat $PIDFILE`
    if ps $pid >/dev/null 2>/dev/null; then
	log_it_error "Already is running with pid $pid, can't run the second instance"
	exit 1
    else
	log_it_notice " PID \"$pid\" is not present is table. Removing pid file and continue the check'n'reconnect"
	rm $PIDFILE
    fi
fi
echo $$ > $PIDFILE


while true; do
    if /opt/kelvpn/sbin/kelvpn_check_tun.sh; then
	log_it_debug "Tunnel works and internet is present. Sleep $ts_check_tun"
	sleep $ts_check_tun
	continue;
    fi
    log_it "Bringing up VPN"

    servers=`timeout 10 /opt/kelvpn/bin/KelVPNCli -L | grep '|' | grep Poland | awk '{print $2;}'`

    for s in $servers; do
	kelvpn_service_restart
	sleep 3
	log_it "Trying to connect with server $s"
	if timeout 20 /opt/kelvpn/bin/KelVPNCli -C $s >> $log_it_out; then
	    log_it_debug "KelVPNCli -C execution returned $?"
	    if ip link show tun0; then
		log_it "Tun is present"
	    else
		log_it_error "No tun, looks connection wasn't successful. Waiting for 3 sec and trying another server"
		#sleep 3
		continue
	    fi
	    log_it_notice "Connected to $s. Now lets check the internet connection itself"
	    if /opt/kelvpn/sbin/kelvpn_check_tun.sh; then
		log_it "Tunnel works and internet is present"
		break;
	    else
		log_it_error "Can't ping gateway ip address, lets try another server"
		if timeout 10 /opt/kelvpn/bin/KelVPNCli -D; then 
		    log_it_notice "Disconnected from $s"
		else
		    log_it_error "Failed to disconnect from $s"
		    continue;
		fi
	    fi
	else
	    echo "[ ] Failed to connect with $s, trying the next one" >> $log
	fi
    done
done
